{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvCalculator.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvCalculator;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  JvFormCalculator, JvBaseDlg, JvTypes;

type
  TJvCalculator = class(TJvCommonDialogP)
  private
    FValue: Extended;
    Ftitle: string;
  protected
  public
    constructor Create(AOwner: TComponent);override;
  published
    property Title:string read Ftitle write FTitle;
    property Value:Extended read FValue write FValue;
    procedure Execute;override;
  end;

implementation

resourcestring
   RC_CalcTitle            =     'Calculator';

{**************************************************}
constructor TJvCalculator.Create(AOwner: TComponent);
begin
   inherited;
   FValue:=0.0;
   FTitle:=RC_CalcTitle;
end;
{**************************************************}
procedure TJvCalculator.Execute;
begin
   with TFormCalc.Create(Application) do
   begin
      SetResult(FValue);
      showmodal;
      FValue:=GetResult;
      free;
   end;
end;
{**************************************************}
end.
