{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvCalculatorBox.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvCalculatorBox;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, JvCustomBox,
  Buttons, JvTypes, JvCalculator;

type
  TJvCalculatorBox = class(TJvCustomBox)
  private
    FLastValue: Extended;
    procedure SetFileName(Value: Extended);
    function GetFileName: Extended;
  protected
    procedure BtnClick(Sender: TObject);override;
    procedure PreEdit(Sender: TObject);
    procedure PostEdit(Sender: TObject);
  public
    constructor Create(AOwner: TComponent);override;
  published
    property Value:Extended read GetFileName write SetFileName;
  end;


implementation

{*****************************************************}
constructor TJvCalculatorBox.Create(AOwner: TComponent);
begin
  inherited;
  Button.Glyph.LoadFromResourceName(hinstance,'CALC');
  Edit.Text := '0';
  FLastValue := 0;
  GetEdit.OnEnter := PreEdit;
  GetEdit.OnExit := PostEdit;
end;
{*****************************************************}
procedure TJvCalculatorBox.SetFileName(Value: Extended);
begin
  Edit.Text := FloatToStr(Value);
end;
{*****************************************************}
function TJvCalculatorBox.GetFileName: Extended;
begin
  try
    result := StrToFloat(Edit.Text);
  except
    result := FLastValue;
  end;
end;
{*****************************************************}
procedure TJvCalculatorBox.BtnClick(Sender: TObject);
begin
  with TJvCalculator.Create(nil) do
  begin
    Value := GetFileName;
    Execute;
    SetFileName(Value);
    Free;
  end;
end;
{*****************************************************}
procedure TJvCalculatorBox.PostEdit(Sender: TObject);
begin
  try
    FLastValue := StrToFloat(Edit.Text);
  except
    SetFileName(FLastValue);
    Beep;
  end;
end;
{*****************************************************}
procedure TJvCalculatorBox.PreEdit(Sender: TObject);
begin
  FLastValue := GetFileName;
end;
{*****************************************************}
end.
