{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvFormPatch.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvFormPatch;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, JvSpeedButton, StdCtrls, JvCustomBox, JvFileNameBox;

type
  TfoPatch = class(TForm)
    BUSpeedButton1: TJvSpeedButton;
    BUSpeedButton2: TJvSpeedButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    BUFileNameBox1: TJvFileNameBox;
    BUFileNameBox2: TJvFileNameBox;
    procedure BUButton1Click(Sender: TObject);
  private
    function Crypt(Value: Byte): byte;
  public
    res:TstringList;
    FPos:Integer;
    procedure LoadFromStr(Value:TstringList);
    function SetFromStr:TstringList;
  end;

implementation

{$R *.DFM}

{*********************************************************************}
procedure TfoPatch.LoadFromStr(Value: TstringList);
begin
   if Value.Count>2 then
   begin
      self.BUFileNameBox1.FileName:=Value[0];
      self.BUFileNameBox2.FileName:=Value[1];
   end;
end;
{*********************************************************************}
function TfoPatch.SetFromStr: TstringList;
begin
   result:=res;
end;
{*********************************************************************}
function TfoPatch.Crypt(Value:Byte):byte;
begin
   if self.edit1.text='' then result:=Value
   else
   begin
     Fpos:=(Fpos+1)mod length(self.edit1.text);
     result:=Value xor (byte(self.edit1.text[Fpos+1]));
   end;
end;
{*********************************************************************}
procedure TfoPatch.BUButton1Click(Sender: TObject);
var
   f,g:file of byte;
   buf1,buf2:array [0..1024] of byte;
   i,l:Integer;
   res1,res2:Integer;
   icount,lastcount:Integer;
begin
   FPos:=-1;
   self.Tag:=0;
   res:=TstringList.Create;
   res.add(self.BUFileNameBox1.FileName);
   res.add(self.BUFileNameBox2.FileName);
   assignfile(f,self.BUFileNameBox1.FileName);
   assignfile(g,self.BUFileNameBox2.FileName);
   reset(f);
   reset(g);
   self.caption:='BU - Patcher Editor : Comparing files 0%';
   Application.ProcessMessages;
   l:=res.add(IntToStr(filesize(f)));
   res.add(IntToStr(filesize(g)));
   icount:=0;
   lastcount:=0;
   while not(eof(f)) and not(eof(g)) do
   begin
      self.caption:='BU - Patcher Editor : Comparing files '+IntToStr(icount div l)+'%';
      Application.ProcessMessages;
      blockread(f,buf1,1024,res1); //f = original file
      blockread(g,buf2,1024,res2); //g = patched file
      if res1=res2 then
      begin
         for i:=0 to res1-1 do
         begin
            inc(icount);
            if buf1[i]<>buf2[i] then
            begin
               res.add(IntToStr(icount-lastcount)+'|'+char(Crypt(buf2[i])));
               lastcount:=icount;
            end;
         end;
      end;
   end;

   self.caption:='BU - Patcher Editor : end step ...';
   Application.ProcessMessages;
   if res1>res2 then
   begin
      //f>g original>patched
      for i:=0 to res2-1 do
      begin
         inc(icount);
         if buf1[i]<>buf2[i] then
         begin
            res.add(IntToStr(icount-lastcount)+'|'+char(Crypt(buf2[i])));
            lastcount:=icount;
         end;
      end;

      //telling it's the end ...
      res.add('end%'+IntToStr(icount));
   end
   else if res2>res1 then
   begin
      //g>f patched>original

      //comparing last bytes
      for i:=0 to res1-1 do
      begin
         inc(icount);
         if buf1[i]<>buf2[i] then
         begin
            res.add(IntToStr(icount-lastcount)+'|'+char(Crypt(buf2[i])));
            lastcount:=icount;
         end;
      end;

      //adding the rest
      for i:=res1 to res2-1 do
           res.add(char(Crypt(buf2[i])));

      //adding the rest of the file
      while not(eof(g)) do
      begin
         blockread(g,buf2,1024,res2);
         for i:=0 to res2-1 do
            res.add(char(Crypt(buf2[i])));
      end;
   end;
   closefile(f);
   closefile(g);
   self.close;
end;
{*********************************************************************}
end.
