{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvHeaderControl.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvHeaderControl;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, JvTypes;

type
  TJvHeaderControl = class(THeaderControl)
  private
    FColor,FSaved:TColor;
    FOnMouseEnter : TNotifyEvent;
    FOnMouseLeave : TNotifyEvent;
    FOnParentColorChanged : TNotifyEvent;
    FOnCtl3DChanged : TNotifyEvent;
    FOver:boolean;
    procedure MouseEnter(var msg:Tmessage); message CM_MOUSEENTER;
    procedure MouseLeave(var msg:Tmessage); message CM_MOUSELEAVE;
    procedure CMCtl3DChanged(var Message: TMessage); message CM_CTL3DCHANGED;
    procedure CMParentColorChanged(var Message: TMessage); message CM_ParentColorChangeD;
  protected
  public
    constructor Create(AOwner: TComponent);override;
  published
    property HintColor:TColor read FColor write FColor default clInfoBk;
    property OnMouseEnter : TNotifyEvent read FonMouseEnter write FonMouseEnter;
    property OnMouseLeave : TNotifyEvent read FonMouseLeave write FonMouseLeave;
    property OnParentColorChange : TNotifyEvent read FonParentColorChanged write FonParentColorChanged;
    property OnCtl3DChanged : TNotifyEvent read FonCtl3DChanged write FonCtl3DChanged;
  end;

implementation

{***********************************************}
constructor TJvHeaderControl.Create(AOwner: TComponent);
begin
   FColor:=clInfoBk;
   FOver:=false;
   inherited Create(AOwner);
   Controlstyle := Controlstyle + [csAcceptsControls];
end;
{***********************************************}
procedure TJvHeaderControl.MouseEnter(var msg:Tmessage);
begin
   FOver:=true;
   FSaved:=Application.HintColor;
   Application.HintColor:=FColor;
   if Assigned(FonMouseEnter) then FonMouseEnter(self);
end;
{**************************************************}
procedure TJvHeaderControl.MouseLeave(var msg:Tmessage);
begin
   Application.HintColor:=FSaved;
   FOver:=false;
   if Assigned(FonMouseLeave) then FonMouseLeave(self);
end;
{**************************************************}
procedure TJvHeaderControl.CMCtl3DChanged(var Message: TMessage);
begin
   inherited;
   if Assigned(FonCtl3DChanged) then FonCtl3DChanged(self);
end;
{**************************************************}
procedure TJvHeaderControl.CMParentColorChanged(var Message: TMessage);
begin
   inherited;
   if Assigned(FonParentColorChanged) then FonParentColorChanged(Self);
end;
{******************************************************************************}
end.
