{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvOutOfMemoryDlg.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvOutOfMemoryDlg;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  JvBaseDlg, JvHDialogs2, JvTypes;

type
  TJvOutOfMemoryDlg = class(TJvCommonDialog)
  private
    FCaption: string;
    FOwner:THandle;
  protected
  public
    constructor Create(AOwner: TComponent);override;
  published
    function Execute:boolean;override;
    function ExecuteEx(style : integer):Integer;
    property Title:string read FCaption write FCaption;
  end;

implementation

{**************************************************}
constructor TJvOutOfMemoryDlg.Create(AOwner: TComponent);
begin
   inherited;
   if (AOwner is TForm) then
      FOwner:=(Aowner as TForm).Handle
   else
      FOwner:=Application.Handle;
end;
{**************************************************}
function TJvOutOfMemoryDlg.Execute: boolean;
begin
   result:=ExecuteEx(MB_OK)=MB_OK;
end;
{**************************************************}
function TJvOutOfMemoryDlg.ExecuteEx(style: integer): Integer;
var
  Str1:PChar;
begin
   if FCaption='' then Str1:=nil else Str1:=pchar(FCaption);
   result:=SHOutOfMemoryMessageBox(FOwner,Str1,style);
end;
{**************************************************}
end.
