{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvPasswordForm.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvPasswordForm;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, 
  JvFormPass, JvBaseDlg, JvTypes;

type
  TJvPasswordForm = class (TJvCommonDialogP)
  private
    Pass:TPassForm;
    FTitle:string;
    FOkCaption:string;
    FCancelCaption:string;
    FLabelCaption:string;
    FTextValue:string;
    FOnCancel:TNotifyEvent;
    FOnOk:TOnOk;
    FPassChar:char;
    procedure OnOkClick(Sender: TObject);
    procedure OnCancelClick(Sender: TObject);
  protected
  public
    constructor Create(AOwner: TComponent);override;
  published
    procedure Execute;override;
    property Title:string read FTitle write FTitle;
    property OkCaption:string read FOkCaption write FOkCaption;
    property CancelCaption:string read FCancelCaption write FCancelCaption;
    property LabelCaption:string read FLabelCaption write FLabelCaption;
    property TextValue:string read FTextValue write FTextValue;
    property OnCancel:TNotifyevent read FOnCancel write FOnCancel;
    property OnOk:TOnOk read FOnOk write FOnOk;
    property PasswordChar:Char read FPassChar write FPassChar;
  end;

implementation

resourcestring
   RC_PassEnter            =     'Enter password';
   RC_OkCaption            =     '&Ok';
   RC_CancelCaption        =     '&Cancel';
   RC_PassChar             =     '*';
   RC_LabelPassCaption     =     'Username';

{**************************************************}
procedure TJvPasswordForm.OnOkClick(Sender: TObject);
var
   can:boolean;
begin
   try
      Can:=false;
      if Assigned(FOnOk) then
         FOnOk(self,Pass.buEdit1.text,can);
      if can then
      begin
         Pass.buBitBtn2.OnClick:=nil;
         Pass.Close;
      end;
   except
   end;
end;
{**************************************************}
procedure TJvPasswordForm.OnCancelClick(Sender: TObject);
begin
   if Assigned(FOnCancel) then
      FOnCancel(self);
end;
{**************************************************}
constructor TJvPasswordForm.Create(AOwner: TComponent);
begin
   inherited;
   FTitle:=RC_PassEnter;
   FOkCaption:=RC_OkCaption;
   FCancelCaption:=RC_CancelCaption;
   FLabelCaption:=RC_LabelPassCaption;
   FTextValue:='';
   FPassChar:=RC_PassChar[1];
end;
{**************************************************}
procedure TJvPasswordForm.Execute;
begin
   try
     if Pass=nil then
          Pass:=TPassForm.Create(Application);
     Pass.Caption:=FTitle;
     Pass.buBitbtn1.caption:=FOkCaption;
     Pass.buBitBtn2.caption:=FCancelCaption;
     Pass.label1.caption:=FLabelCaption;
     Pass.buedit1.text:=FTextValue;
     Pass.buedit1.PasswordChar:=FPassChar;
     Pass.BuBitbtn1.onclick:=OnOkClick;
     Pass.bubitbtn2.onclick:=OnCancelClick;
     Pass.ShowModal;
   finally
     Pass.free;
     Pass:=nil;
   end;
end;
{**************************************************}
end.
