{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvRealLabel.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvRealLabel;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, StdCtrls,
  Forms;

type
  TJvRealLabel = class(TCustomLabel)
  private
    FOnMouseEnter : TNotifyEvent;
    FOnMouseLeave : TNotifyEvent;
    FOnCtl3DChanged : TNotifyEvent;
    FOnParentColorChanged : TNotifyEvent;
    FText : string;
    FSleep:Integer;
    FError:boolean;
    procedure MouseEnter(var msg:Tmessage); message CM_MOUSEENTER;
    procedure MouseLeave(var msg:Tmessage); message CM_MOUSELEAVE;
    procedure CMCtl3DChanged(var Message: TMessage); message CM_CTL3DCHANGED;
    procedure CMParentColorChanged(var Message: TMessage); message CM_ParentColorChangeD;
    procedure SetText(Value:string);
  protected
  public
    constructor Create(AOwner: TComponent);override;
  published
    property Alignment;
    property AutoSize;
    property FocusControl;
    property DragCursor;
    property DragMode;
    property Font;
    property ParentColor;
    property Color;
    property ShowHint;
    property ParentFont;
    property ParentShowHint;
    property Layout;
    property ShowAccelChar;
    property PopupMenu;
    property Transparent;
    property WordWrap;
    property Align;
    property Left;
    property Visible;
    property Top;
    property Height;
    property Width;
    property Cursor;
    property Enabled;
    property Hint;
    property Text:string read FText write SetText;
    property SleepTime:Integer read FSleep write FSleep default 100;
    property MakeErrors : boolean read FError write FError default true;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseMove;
    property OnMouseDown;
    property OnMouseUp;
    property OnStartDrag;
    property OnMouseEnter : TNotifyEvent read FonMouseEnter write FonMouseEnter;
    property OnMouseLeave : TNotifyEvent read FonMouseLeave write FonMouseLeave;
    property OnCtl3DChanged : TNotifyEvent read FonCtl3DChanged write FonCtl3DChanged;
    property OnParentColorChange : TNotifyEvent read FonParentColorChanged write FonParentColorChanged;
  end;

implementation

{**************************************************}
constructor TJvRealLabel.Create(AOwner: TComponent);
begin
   Fsleep:=100;
   FError:=true;
   inherited;
   FText:=Caption;
   SetText(caption);
end;
{**************************************************}
procedure TJvRealLabel.CMCtl3DChanged(var Message: TMessage);
begin
   inherited;
   if Assigned(FonCtl3DChanged) then FonCtl3DChanged(self);
end;
{**************************************************}
procedure TJvRealLabel.CMParentColorChanged(var Message: TMessage);
begin
   inherited;
   if Assigned(FonParentColorChanged) then FonParentColorChanged(Self);
end;
{**************************************************}
procedure TJvRealLabel.MouseEnter(var msg:Tmessage);
begin
   inherited;
   if Assigned(FonMouseEnter) then FonMouseEnter(self);
end;
{**************************************************}
procedure TJvRealLabel.MouseLeave(var msg:Tmessage);
begin
   inherited;
   if Assigned(FonMouseLeave) then FonMouseLeave(self);
end;
{**************************************************}
procedure TJvRealLabel.SetText(Value:string);
var
   i,j:Integer;
   cap:string;
begin
   Ftext:=Value;
   if not(csLoading in componentstate)and not(csDesigning in ComponentState) then
   begin
      randomize;
      cap:='';
      for i:=1 to length(Value) do
      begin
         caption:=Copy(Value,1,i-1);
         cap:=caption;
         j:=random(10);
         if (j=7) and (Ferror) then cap:=cap+char(ord(Value[i])-random(10))
         else cap:=cap+Value[i];
         caption:=cap;
         Application.ProcessMessages;
         if (Ferror) and (j<>7) then sleep(FSleep)
         else sleep(2*FSleep);
      end;
   end;
   caption:=Value;
end;
{**************************************************}
end.
