{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvRecentDocs.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvRecentDocs;

{$ObjExportAll On}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, JvDirectories,
  JvTypes, ShlObj, JvFileInformations;

type
  TJvRecentDocs = class(TComponent)
  private
    FDirs:TJvDirectories;
    FLink:TJvFileInformations;
  protected
  public
    constructor Create(AOwner: TComponent);override;
    destructor Destroy;override;
  published
    function GetDocs:TstringList;
    procedure AddToDocuments(Value:string);
  end;

implementation

{*****************************************************}
constructor TJvRecentDocs.Create(AOwner: TComponent);
begin
   inherited;
   FDirs:=TJvDirectories.Create(self);
   Flink:=TJvFileInformations.Create(Self);
end;
{*****************************************************}
destructor TJvRecentDocs.Destroy;
begin
   FDirs.free;
   FLink.free;
   inherited;
end;
{*****************************************************}
function TJvRecentDocs.GetDocs:TstringList;
var
   path:string;
   t:TSearchRec;
   res:Integer;
begin
   Result:=TstringList.Create;
   Result.Clear;

   path:=FDirs.Recent+'\';
   //search for all files
   res:=FindFirst(path+'*.*',faAnyFile,t);
   while res=0 do
   begin
      if (t.name<>'.')and(t.name<>'..') then
          Result.Add(path+T.Name);
      res:=FindNext(t);
   end;
   FindClose(t);
end;
{*****************************************************}
procedure TJvRecentDocs.AddToDocuments(Value:string);
begin
   SHAddToRecentDocs (SHARD_PATH, PChar(Value));
end;
{*****************************************************}
end.
