{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvRichEdit.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvRichEdit;

{$ObjExportAll On} 

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, JvTypes,
  ComCtrls;

type
  TJvRichEdit = class(TRichEdit)
  private
    FColor,FSaved:TColor;
    FOnMouseEnter : TNotifyEvent;
    FOnMouseLeave : TNotifyEvent;
    FOnCtl3DChanged : TNotifyEvent;
    FOnParentColorChanged : TNotifyEvent;
    FOnHScroll: TNotifyEvent;
    FOnVScroll: TNotifyEvent;
    procedure WMHScroll(var Message: TWMHScroll); message WM_HSCROLL;
    procedure WMVScroll(var Message: TWMVScroll); message WM_VSCROLL;
    procedure MouseEnter(var msg:Tmessage); message CM_MOUSEENTER;
    procedure MouseLeave(var msg:Tmessage); message CM_MOUSELEAVE;
    procedure CMCtl3DChanged(var Message: TMessage); message CM_CTL3DCHANGED;
    procedure CMParentColorChanged(var Message: TMessage); message CM_ParentColorChangeD;
  protected
  public
    constructor Create(AOwner: TComponent);override;
  published
    property HintColor:TColor read FColor write FColor default clInfoBk;
    property OnMouseEnter : TNotifyEvent read FonMouseEnter write FonMouseEnter;
    property OnMouseLeave : TNotifyEvent read FonMouseLeave write FonMouseLeave;
    property OnCtl3DChanged : TNotifyEvent read FonCtl3DChanged write FonCtl3DChanged;
    property OnParentColorChange : TNotifyEvent read FonParentColorChanged write FonParentColorChanged;
    property OnVerticalScroll:TNotifyEvent read FOnVScroll write FOnVScroll;
    property OnHorizontalScroll:TNotifyEvent read FOnHScroll write FOnHScroll;
  end;

implementation

{*****************************************************************}
constructor TJvRichEdit.Create(AOwner: TComponent);
begin
   inherited;
   FColor:=clInfoBk;
   Controlstyle := Controlstyle + [csAcceptsControls];
end;
{*****************************************************************}
procedure TJvRichEdit.CMCtl3DChanged(var Message: TMessage);
begin
   inherited;
   if Assigned(FonCtl3DChanged) then FonCtl3DChanged(self);
end;
{**************************************************}
procedure TJvRichEdit.CMParentColorChanged(var Message: TMessage);
begin
   inherited;
   if Assigned(FonParentColorChanged) then FonParentColorChanged(Self);
end;
{**************************************************}
procedure TJvRichEdit.WMHScroll(var Message: TWMHScroll);
begin
   inherited;
   if Assigned(FOnHScroll) then
      FOnHScroll(self);
end;
{**************************************************}
procedure TJvRichEdit.WMVScroll(var Message: TWMVScroll);
begin
   inherited;
   if Assigned(FOnVScroll) then
      FOnVScroll(self);
end;
{**************************************************}
procedure TJvRichEdit.MouseEnter(var msg:Tmessage);
begin
   FSaved:=Application.HintColor;
   Application.HintColor:=FColor;
   if Assigned(FonMouseEnter) then FonMouseEnter(self);
end;
{**************************************************}
procedure TJvRichEdit.MouseLeave(var msg:Tmessage);
begin
   Application.HintColor:=FSaved;
   if Assigned(FonMouseLeave) then FonMouseLeave(self);
end;
{**************************************************}
end.
