{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvShellAbout.PAS, released on 2001-02-28.

The Initial Developer of the Original Code is Sbastien Buysse [sbuysse@buypin.com]
Portions created by Sbastien Buysse are Copyright (C) 2001 Sbastien Buysse.
All Rights Reserved.

Contributor(s): Michael Beck [mbeck@bigfoot.com].

Last Modified: 2000-02-28

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

Known Issues:
-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$I JEDI.INC}

unit JvShellAbout;

{$ObjExportAll On} 

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, 
  ShellApi, JvBaseDlg;

type
  TJvShellAbout = class(TJvCommonDialogP)
  private
    FHandle:THandle;
    FIcon:TIcon;
    FText,FTitle:string;
    procedure SetIcon(Value:TIcon);
  protected
  public
    constructor Create(AOwner: TComponent);override;
    destructor Destroy;override;
  published
    property Title:string read Ftitle write FTitle;
    property Text:string read FText write FText;
    property Icon:TIcon read FIcon write SetIcon;
    procedure ShowModal;
    procedure Execute;override;
  end;

implementation

resourcestring
  RC_DefaultTitle         =     'BuyPin Software';
  RC_DefaultText          =     'Place your text here';

{**************************************************}
procedure TJvShellAbout.SetIcon(Value:TIcon);
begin
   FIcon.assign(Value);
end;
{**************************************************}
constructor TJvShellAbout.Create(AOwner: TComponent);
begin
   inherited;
   FTitle:=RC_DefaultTitle;
   FText:=RC_DefaultText;
   FHandle:=(AOwner as TForm).Handle;
   FIcon:=TIcon.Create;
end;
{**************************************************}
destructor TJvShellAbout.Destroy;
begin
   FIcon.free;
   inherited;
end;
{**************************************************}
procedure TJvShellAbout.ShowModal;
begin
   ShellAbout(FHandle,pchar(Ftitle),pchar(FText),FIcon.Handle);
end;
{**************************************************}
procedure TJvShellAbout.Execute;
begin
   ShowModal;
end;
{**************************************************}
end.
